﻿using System.Collections.Generic;
using System.Linq;
using NUnit.Framework;
using TDD_Katas_project.Utility;

namespace TDD_Katas_project.The_Natural_String_Sorting_Kata
{
    [TestFixture]
    [Category("The Natural String Kata")]
    public class NaturalStringSortingTest
    {
        #region Private Member Variables
        private NaturalStringSorting _naturalStringSorting;
        private string[] _strings;
        #endregion

        #region Setup/TearDown
        [TestFixtureSetUp]
        public void Setup()
        {
            _naturalStringSorting = new NaturalStringSorting();
            _strings = new[] { "a1", "1", "3", "2", "b1", "1a", "b3", "23", "z 21", "21 1", "z22", "0" };
        }
        [TestFixtureTearDown]
        public void TearDown()
        {
            _naturalStringSorting = null;
            _strings = null;
        }
        #endregion

        #region Test Methods

        [Test]
        public void CanSortStringDefaultOrder()
        {

            var sortString = _naturalStringSorting.SortString(_strings);
            SimpleNaturalStringOrder[] stringOrders = { new SimpleNaturalStringOrder { ItemValue = "a1" }, new SimpleNaturalStringOrder { ItemValue = "1" }, new SimpleNaturalStringOrder { ItemValue = "a2" } };  //, "1", "3", "2", "b1", "1a", "b3", "23", "z 21", "21 1", "z22", "0" };

            var sortString1 = _naturalStringSorting.SortStringUsingNaturalStringSorter(stringOrders);
            string[] result = { "0", "1", "1a", "2", "3", "23", "21 1", "a1", "b1", "b3", "z 21", "z22" };
            Assert.That(sortString, Is.EqualTo(ToList(result)));
        }
        [Test]
        public void CanSortStringDesOrder()
        {
            var sortString = _naturalStringSorting.SortString(_strings, NaturalStringSorting.SortOrder.Descending);
            string[] result = { "z22", "z 21", "b3", "b1", "a1", "21 1", "23", "3", "2", "1a", "1", "0" };
            Assert.That(sortString, Is.EqualTo(ToList(result)));

        }
        #endregion

        #region Private Methods
        private List<string> ToList(params string[] items)
        {
            return items.ToList();
        }

        #endregion
    }
}
